#include <iostream>
#include <iomanip>
using namespace std;

#define LINHAS    5
#define COLUNAS   5

class Matrix {
  int mat[LINHAS][COLUNAS];

public:
  Matrix();
  Matrix(int init[][COLUNAS]);
  void entrada();
  void saida();
  int getElement(int i, int k) const;
  Matrix operator +(const Matrix& mat2) const;
  Matrix operator -(const Matrix& mat2) const;
  Matrix operator *(const Matrix& mat2) const;
  Matrix operator *(int escalar) const;
};


Matrix::Matrix()
{
  int i, k;

  for (i=0; i < LINHAS; i++)
    for (k=0; k < COLUNAS; k++)
      mat[i][k] = 0;
}

Matrix::Matrix(int init[][COLUNAS])
{
  int i, k;

  for (i=0; i < LINHAS; i++)
    for (k=0; k < COLUNAS; k++)
      mat[i][k] = init[i][k];
}

void Matrix::entrada ()
{
  int i, k;
  for (i=0; i < LINHAS; i++) {
    for (k=0; k < COLUNAS; k++) {
      cout << "\t elemento (" << i << "," << k 
	   << "): ";
      cin >> mat[i][k];
    }
  }
}

void Matrix::saida ()
{
  int i, k;
  for (i=0; i < LINHAS; i++) {
    //    cout.setf(ios::showpoint|ios::fixed);
    //    cout.precision(2);
    for (k=0; k < COLUNAS; k++)
      cout << setw(5) << mat[i][k] << "\t";
    cout << endl;
  }
}

int Matrix::getElement(int i, int k) const
{
  return (mat[i][k]);
}

Matrix Matrix::operator+ (const Matrix& mat_2) const
{
  int i, k;
  int soma[LINHAS][COLUNAS];

  for (i=0; i < LINHAS; i++)
    for (k=0; k < COLUNAS; k++)
      soma[i][k] = mat[i][k] + mat_2.mat[i][k];
  
  return (Matrix(soma));
}

Matrix Matrix::operator- (const Matrix& mat_2) const
{
  int i, k;
  int soma[LINHAS][COLUNAS];

  for (i=0; i < LINHAS; i++)
    for (k=0; k < COLUNAS; k++)
      soma[i][k] = mat[i][k] - mat_2.getElement(i,k);
  
  return (Matrix(soma));
}


Matrix Matrix::operator* (int escalar) const
{
  int i, k;
  int prod[LINHAS][COLUNAS];

  for (i=0; i < LINHAS; i++)
    for (k=0; k < COLUNAS; k++)
      prod[i][k] = escalar * mat[i][k];
  
  return (Matrix(prod));
}

Matrix Matrix::operator* (const Matrix& mat_2) const
{
  int i,j,p,q;
  int prod[LINHAS][COLUNAS] = {0};

  for (i=0; i < LINHAS; i++)
    for (j=0; j < COLUNAS; j++) {
      for (p=0; p < COLUNAS; p++)
	prod[i][j] += mat[i][p] * mat_2.mat[p][j];
    }
  
  return (Matrix(prod));
}



main () 
{
  Matrix matriz, soma, result;
  
  cout << "Forneca os valores da Matriz 1:\n";
  matriz.entrada();
  cout << "\n\n";
  cout << "Forneca os valores da Matriz 2:\n";
  soma.entrada();

  result = matriz * soma;
  cout << "\n\nProduto das matrizes = \n";
  result.saida();

  result = matriz * 4;
  cout << "\n\nProduto da Matriz 1 pelo escalar 4 = \n";
  result.saida();

  result = soma + matriz;
  cout << "\n\nSoma das matrizes = \n";
  result.saida();
}

